\documentclass[border=5pt, multi, tikz]{standalone}
\usetikzlibrary{quotes,arrows.meta}
\tikzset{
	annotated cuboid/.pic={
		\tikzset{%
			every edge quotes/.append style={midway, auto},
			/cuboid/.cd,
			#1
		}
		\draw [every edge/.append style={pic actions, densely dashed, opacity=.5}, pic actions]
		(0,0,0) coordinate (o) -- ++(-\cubescale*\cubex,0,0) coordinate (a) -- ++(0,-\cubescale*\cubey,0) coordinate (b) edge coordinate [pos=1] (g) ++(0,0,-\cubescale*\cubez)  -- ++(\cubescale*\cubex,0,0) coordinate (c) -- cycle
		(o) -- ++(0,0,-\cubescale*\cubez) coordinate (d) -- ++(0,-\cubescale*\cubey,0) coordinate (e) edge (g) -- (c) -- cycle
		(o) -- (a) -- ++(0,0,-\cubescale*\cubez) coordinate (f) edge (g) -- (d) -- cycle;
		\path [every edge/.append style={pic actions, |-|}]
		(b) +(0,-5pt) coordinate (b1) edge ["\xtext \cubeunits"'] (b1 -| c)
		(b) +(-5pt,0) coordinate (b2) edge ["\ztext \cubeunits"] (b2 |- a)
		(c) +(3.5pt,-3.5pt) coordinate (c2) edge ["\ytext \cubeunits"'] ([xshift=3.5pt,yshift=-3.5pt]e)
		;
	},
	/cuboid/.search also={/tikz},
	/cuboid/.cd,
	width/.store in=\cubex,
	height/.store in=\cubey,
	depth/.store in=\cubez,
	units/.store in=\cubeunits,
	scale/.store in=\cubescale,
	xtext/.store in=\xtext,
	ytext/.store in=\ytext,
	ztext/.store in=\ztext,
	width=10,
	height=10,
	depth=10,
	units=cm,
	scale=.1,
	xtext=\cubex,
	ytext=\cubey,
	ztext=\cubez,
}

\begin{document}
	\begin{tikzpicture}
	\pic {annotated cuboid={{width=30, height=23, depth=30, units={}, xtext={$h_x$}, ytext={$h_y$}, ztext={$a$}}}};
	\end{tikzpicture}
\end{document}
